//==============================================
//	FT_ALTERA FTDI FT2232C MPSSE JTAG module	
//		2005/03/01		Ver 0.0					
//												
//	Compiled VisualC++ Ver5.0 with D2XX DLL ver.1.10
//												
//	Windows98SE    with D2XX Driver ver.1.10	
//	Windows2000Pro with D2XX Driver ver.1.03	
//												
//		Programed By	Y.Sakamoto				
//		Copyright (C)2005 Y.Sakamoto			
//==============================================


//==============================================
//#define	JTAG_SIZE	(JTAG_BUFFER_MAX)
//#define	JTAG_SIZE	(3968*16)	/*	62*16=3968	*/
#define	JTAG_SIZE	(0x10000)


//==============================================
//	FT_ALTERA Subroutine
//==============================================
BOOL	RunTestIdle(void);
BOOL	Bypass(void);
BOOL	VerifyChain(void);
BOOL	GetIdCode(DWORD* pdwIdCode);
DEVICE_INFO_T* GetDeviceInfo(DWORD dwIdCode);

BOOL	Configure(DEVICE_INFO_T* ptDeviceInfo, char* szFileName);
BOOL	ProcessFileInput(DEVICE_INFO_T* ptDeviceInfo, char* szFileName);
BOOL	Startup(DEVICE_INFO_T* ptDeviceInfo);
BOOL	CheckStatus(DEVICE_INFO_T* ptDeviceInfo);
BOOL	PostBypass(DEVICE_INFO_T* ptDeviceInfo);

int	GetPinCount(DEVICE_INFO_T* ptDeviceInfo);
BOOL	MakeBoundaryScan(DEVICE_INFO_T* ptDeviceInfo, BSCAN_DATA_T* ptBscanData);
BOOL	DoBoundaryScan(BSCAN_DATA_T* ptBscanData);
BOOL	BoundaryScan(DEVICE_INFO_T* ptDeviceInfo, char* szFileName);
BOOL	BoundaryScanW(BSCAN_DATA_T* ptBscanData);
BOOL	DispBitValue(BYTE* buf, DEVICE_INFO_T* ptDeviceInfo);
BOOL	GetBitValue(BYTE* buf, BSCAN_CELL_T* ptBscanCell);

