// FT_BscanDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include	<stdarg.h>

#include "FPGA.h"
#include "FT_Jtag.h"
#include "FT_Altera.h"

#include "FT_Bscan.h"
#include "FT_BscanDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void	DrawWaveB(CStatic* pm_Frame, int ppin, int ppos, BSCAN_DATA_T* ptBscanData);

int GetTate(CStatic* pm_Frame);
int GetYoko(CStatic* pm_Frame);


BOOL	bFtOpen;
DEVICE_INFO_T*	ptDeviceInfo;
BSCAN_DATA_T*	ptBscanData;
BSCAN_DATA_T	tBscanData;

BOOL	bBscanFirst;
BOOL	bBscanDo;
int		nBscanCnt;


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFT_BscanDlg _CAO

CFT_BscanDlg::CFT_BscanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFT_BscanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFT_BscanDlg)
	m_Edit1 = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFT_BscanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFT_BscanDlg)
	DDX_Control(pDX, IDC_BUTTON1, m_Button1);
	DDX_Control(pDX, IDC_BUTTON2, m_Button2);
	DDX_Control(pDX, IDC_SCROLLBAR2, m_Horz);
	DDX_Control(pDX, IDC_CHECK1, m_Check1);
	DDX_Control(pDX, IDC_SCROLLBAR1, m_Vert);
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Control(pDX, IDC_FRAME, m_Frame);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFT_BscanDlg, CDialog)
	//{{AFX_MSG_MAP(CFT_BscanDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFT_BscanDlg bZ[W nh

BOOL CFT_BscanDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB

	m_Check1.EnableWindow(false);
	m_Button2.EnableWindow(false);
	m_Vert.EnableWindow(false);
	m_Horz.EnableWindow(false);
	m_Vert.SetScrollPos(0);
	m_Horz.SetScrollPos(0);

	bFtOpen	= FALSE;

	bBscanFirst	= TRUE;
	bBscanDo	= FALSE;
	nBscanCnt	= 0;

	ptDeviceInfo	= NULL;
	ptBscanData	= NULL;

	Print("FT2232C(MPSSE) JTAG BOUNDARY SCAN Ver 0.0");
	Print("   Copyright (C)2005 Y.Sakamoto");
	Print("http://hp.vector.co.jp/authors/VA014069/");
	Print("FT2232CFPGAڑFT_OPEN{^܂B");
	Print("̌ABSCAN{^ƃoE_XLsȂ܂B");
	Print("AUTO`FbN500msԊuōXV܂B");
	Print("CycloneEP1C3T100EP1C20F324ɂ̂ݑΉĂ܂B");
	Print("ȊO̕iɑΉ]͂̕₢킹B");

	SetTimer(1, 100, NULL);		//	^C}[Zbg

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CFT_BscanDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CFT_BscanDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		DrawWaveB(&m_Frame, m_Vert.GetScrollPos(), m_Horz.GetScrollPos(), ptBscanData);
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CFT_BscanDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//==============================================
void CFT_BscanDlg::OnButton1() 
{
	BOOL	bFlag;
	DWORD	dwIdCode;

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	m_Check1.EnableWindow(false);
	m_Button2.EnableWindow(false);
	m_Vert.EnableWindow(false);
	m_Horz.EnableWindow(false);
	m_Vert.SetScrollPos(0);
	m_Horz.SetScrollPos(0);

	bBscanFirst	= TRUE;

	ptDeviceInfo	= NULL;
	ptBscanData		= NULL;

	if (!bFtOpen)
	{
		bFlag	= JT_Open(NULL);
		if (!bFlag)	Print("FT2232C OPEN...NG");
		if (!bFlag)	return;

		Print("FT2232C OPEN...OK");
		bFtOpen	= TRUE;
	}
	else
	{
		Print("FT2232C OPEN...OK");
	}

	if (bFtOpen)
	{
		bFlag	= JT_Initialize();
		if (!bFlag)	Print("FT2232C INIT...NG");
		if (!bFlag)	return;

//		bFlag	= JT_CheckPower();
//		if (!bFlag)	Print("TARGET POWER...NG");
//		if (!bFlag)	return;

		bFlag	= RunTestIdle();
		if (!bFlag)	Print("DEVICE INIT...NG");
		if (!bFlag)	return;

		bFlag	= VerifyChain();
		if (!bFlag)	Print("JTAG CHAIN...NG");
		if (!bFlag)	return;

		bFlag	= GetIdCode(&dwIdCode);
		if (!bFlag)	Print("IDCODE...NG");
		if (!bFlag)	return;

		Print("IDCODE=%08lX", dwIdCode);

		ptDeviceInfo	= GetDeviceInfo(dwIdCode);
		if (ptDeviceInfo)
		{
			Print("Device=Altera %s", ptDeviceInfo->szDeviceName);

			if (ptDeviceInfo->ptBscanCell)
			{
				Print("BSCAN SUPPORT BscanLen=%d", ptDeviceInfo->nBscanLen);
			}
			else
			{
				Print("But FT_BSCAN NOT SUPPORT");
			}
		}
		else
		{
			Print("NG, UnKnown");
			return;
		}

		ptBscanData		= &tBscanData;
		bFlag	= MakeBoundaryScan(ptDeviceInfo, ptBscanData);
		if (!bFlag)
		{
			Print("MakeBoundaryScan...NG");
			ptBscanData		= NULL;
			return;
		}

		m_Check1.EnableWindow(true);
		m_Button2.EnableWindow(true);
	}

	return;
}

//==============================================
void CFT_BscanDlg::OnButton2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	if (bFtOpen)
	{
		bBscanDo	= TRUE;
	}
}

//==============================================
void CFT_BscanDlg::OnButton3() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	Invalidate(FALSE);
}

//==============================================
void CFT_BscanDlg::OnButton4() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
}

//	http://www.takebay.net/~daigo-ao/paddlewiki.pl/title_43A1DCA1DC2054697073.html
void CFT_BscanDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	
//	CDialog::OnOK();
}

void CFT_BscanDlg::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	
//	CDialog::Oncancel();
}

void CFT_BscanDlg::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	// {^ŏI邽߂ɒǉ
	EndDialog(0);
	CDialog::OnClose();
}

void CFT_BscanDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	KillTimer(1);		//	^C}[Xgbv

	//	FT2232C CLOSE
	if (bFtOpen)
	{
		JT_Close();
	}
}


void CFT_BscanDlg::Print(char *form, ...)
{
	va_list	argPtr;
	char	str[80+1];

//	m_List1.SetRedraw(false);

	va_start(argPtr, form);
	_vsnprintf(str, 80, form, argPtr);
	{
		int			index;

		index = m_List1.GetCount();
		if (index > 100)
		{
			m_List1.DeleteString(0);
		}

		m_List1.AddString(str);
//		index = m_List1.GetCount();

		m_List1.SetTopIndex(index-1);
	}
	va_end(argPtr);

//	m_List1.SetRedraw(true);
//	m_List1.Invalidate();

	return;
}


//==============================================
void CFT_BscanDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	int	nNewpos	= pScrollBar->GetScrollPos();
	int	iMin, iMax;
	pScrollBar->GetScrollRange(&iMin, &iMax);

	switch(nSBCode)
	{
	case	SB_LINERIGHT:		nNewpos	+= 1;	break;
	case	SB_LINELEFT:		nNewpos	-= 1;	break;
	case	SB_PAGERIGHT:		nNewpos	+= 4;	break;
	case	SB_PAGELEFT:		nNewpos	-= 4;	break;
	case	SB_THUMBPOSITION:
	case	SB_THUMBTRACK:		nNewpos	= nPos;	break;
	default:					break;
	}

	if( nNewpos <  iMin) 		nNewpos	= iMin;
	else if( nNewpos > iMax)	nNewpos	= iMax;

	pScrollBar->SetScrollPos(nNewpos);

	Invalidate(FALSE);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CFT_BscanDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	int	nNewpos	= pScrollBar->GetScrollPos();
	int	iMin, iMax;
	pScrollBar->GetScrollRange(&iMin, &iMax);

	switch(nSBCode)
	{
	case	SB_LINEDOWN:		nNewpos	+= 1;	break;
	case	SB_LINEUP:			nNewpos	-= 1;	break;
	case	SB_PAGEDOWN:		nNewpos	+= 4;	break;
	case	SB_PAGEUP:			nNewpos	-= 4;	break;
	case	SB_THUMBPOSITION:
	case	SB_THUMBTRACK:		nNewpos	= nPos;	break;
	default:					break;
	}

	if( nNewpos <  iMin) 		nNewpos	= iMin;
	else if( nNewpos > iMax)	nNewpos	= iMax;

	pScrollBar->SetScrollPos(nNewpos);

	Invalidate(FALSE);

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}


void CFT_BscanDlg::OnCheck1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	if (m_Check1.GetCheck())
	{
	}
}

void CFT_BscanDlg::OnTimer(UINT nIDEvent) 
{
	BOOL	bFlag;

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	//	100ms * 5 = 0.5sec
	if (m_Check1.GetCheck())
	{
		if (!bBscanDo)
		{
			nBscanCnt ++;
			if (nBscanCnt >= 5)	bBscanDo	= TRUE;
		}
	}

	if (bBscanDo)
	{
		nBscanCnt = 0;

		if (bFtOpen)
		{
			bFlag	= BoundaryScanW(ptBscanData);
			if (!bFlag)
			{
				Print("BoundaryScan...NG");
			}
			else
			{
				if (!m_Check1.GetCheck())
				{
					Print("BoundaryScan...OK");
				}

				if (bBscanFirst)
				{
					m_Vert.SetScrollRange(0, (ptBscanData->nPinCount - GetTate(&m_Frame)));
					m_Horz.SetScrollRange(0, (ptBscanData->nSampling - GetYoko(&m_Frame)));
					m_Vert.EnableWindow(true);
					m_Horz.EnableWindow(true);

					bBscanFirst	= FALSE;
				}

				Invalidate(FALSE);
			}
		}

		if (!bFlag)
		{
			m_Check1.SetCheck(false);
		}

		bBscanDo	= FALSE;
	}


	CDialog::OnTimer(nIDEvent);
}


//==============================================
int GetTate(CStatic* pm_Frame)
{
	DWORD	height;
	DWORD	step_y;

    CRect rc;
	pm_Frame->GetClientRect(&rc);

	height	= rc.bottom - rc.top;
	step_y	= 18;

	return (height/step_y+1);
}


int GetYoko(CStatic* pm_Frame)
{
	DWORD	width;
	DWORD	step_x;
	DWORD	base_x, base_y;

    CRect rc;
	pm_Frame->GetClientRect(&rc);

	width	= rc.right - rc.left;
	step_x	= 3;
	base_x	= 64;

	return ((width-base_x)/step_x+1);
}


void DrawWaveB(CStatic* pm_Frame, int ppin, int ppos, BSCAN_DATA_T* ptBscanData)
{
	DWORD	width;
	DWORD	height;
	DWORD	step_x;
	DWORD	step_y;

	DWORD	base_x, base_y;
	DWORD	edge_y;
	DWORD	x, y;
	BYTE	old;
	BYTE	now;
	int	scnt;

	CDC	*pD1C;
	pD1C	= pm_Frame->GetDC();

    CRect rc;
	pm_Frame->GetClientRect(&rc);

//	rc.DeflateRect(2, 2);

	width	= rc.right - rc.left;
	height	= rc.bottom - rc.top;
	step_x	= 3;
	step_y	= 18;
	edge_y	= 14;
	base_x	= 64;
	base_y	= step_y;


	CDC	*pDC;
	CDC	m_backDc;
	CBitmap	m_backBmp;
    CClientDC	dc(pm_Frame);

	pDC	= &m_backDc;

    pDC->CreateCompatibleDC(&dc);
    m_backBmp.CreateCompatibleBitmap(&dc, width, height);
    pDC->SelectObject(&m_backBmp);

	// [W쐬
	CRgn rgn;
	rgn.CreateRectRgnIndirect(&rc);

	// [W蓖
	pDC->SelectClipRgn(&rgn, RGN_COPY);

//	pDC->FillSolidRect( &rc, RGB(32, 32, 32));
	pDC->FillSolidRect(&rc, RGB(16, 16, 16));

	CPen	myOutPen, myInpPen, *pOldPen;
	CPen	myBackPen, myWhitePen;
    myOutPen.CreatePen(PS_SOLID, 1, RGB(64, 255, 255));
    myInpPen.CreatePen(PS_SOLID, 1, RGB(255, 255, 64));
    myBackPen.CreatePen(PS_SOLID, base_y-edge_y-1, RGB(96, 96, 96));
    myWhitePen.CreatePen(PS_SOLID, 2, RGB(255, 255, 255));
    pOldPen = pDC->SelectObject(&myOutPen);

	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(RGB(255, 255, 255));

	if (!ptBscanData)					goto	SKIP;
	if (!(ptBscanData->pbyTxBuf))		goto	SKIP;
	if (!(ptBscanData->pbyRxBuf))		goto	SKIP;
	if (!(ptBscanData->nSampling))		goto	SKIP;

	//
	BSCAN_CELL_T*	ptBscanCell;
	BYTE* buf;

	ptBscanCell	= &(ptDeviceInfo->ptBscanCell)[ppin];
	//
	while ((base_y<height) && (ptBscanCell->nBitTyp))
	{
		scnt	= ptBscanData->nSampling;

	    pDC->TextOut(4, base_y-step_y+2, ptBscanCell->szPinName, strlen(ptBscanCell->szPinName));

	    pDC->SelectObject(&myBackPen);
        pDC->MoveTo(0, base_y+2);
	    pDC->LineTo(width-1, base_y+2);

		buf	= ptBscanData->pbyRxBuf;
		buf	+= (ptBscanData->nByteLen * ppos);

		GetBitValue(buf, ptBscanCell);
		old	= ptBscanCell->byBitVal & 0x01;
		if (ptBscanCell->byBitVal & 0x02)	pDC->SelectObject(&myInpPen);
		else								pDC->SelectObject(&myOutPen);
		x	= base_x;
		y	= base_y - (old * edge_y);

        pDC->MoveTo(x, y);
		while ((x<width) && (scnt--))
		{
			x	+= step_x;
		    pDC->LineTo(x, y);

			GetBitValue(buf, ptBscanCell);
			now	= ptBscanCell->byBitVal & 0x01;

			y	= base_y - (now * edge_y);
			if (old	!= now)
			{
			    pDC->LineTo(x, y);
				old	= now;
			}
			buf	+= ptBscanData->nByteLen;
		}

		base_y	+= step_y;
		ptBscanCell ++;
	}

    pDC->SelectObject(&myWhitePen);
	pDC->MoveTo(base_x-1, 0);
    pDC->LineTo(base_x-1, height);

SKIP:
    pDC->SelectObject(&myWhitePen);
    pDC->SelectObject(GetStockObject(NULL_BRUSH));
	pDC->Rectangle(&rc);

    pDC->SelectObject(pOldPen);

    // ʂCʂɓ]
    pD1C->BitBlt(0, 0, width, height, pDC, 0, 0, SRCCOPY);

	// [W
	pDC->SelectClipRgn(NULL, RGN_COPY);

	pDC->DeleteDC();
    m_backBmp.DeleteObject();

	pm_Frame->ReleaseDC(pD1C);
}



void CAboutDlg::OnButton1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	ShellExecute(NULL, "open", "http://hp.vector.co.jp/authors/VA014069/", NULL, NULL, SW_SHOWNORMAL);
}


void CFT_BscanDlg::OnButton5() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CDialog::OnOK();
}
