//==============================================
//	FT_MPSSE FT2232C MPSSE JTAG module			
//		2005/03/01		Ver 0.0					
//												
//	Compiled VisualC++ Ver5.0 with D2XX DLL ver.1.10
//												
//	Windows98SE    with D2XX Driver ver.1.10	
//	Windows2000Pro with D2XX Driver ver.1.03	
//												
//		Programed By	Y.Sakamoto				
//		Copyright (C)2005 Y.Sakamoto			
//==============================================


//==============================================
//	FTDI MPSSE Command
//==============================================
/*
Bit 0 - set -ve TCK/SK on write
Bit 1 - bit mode
Bit 2 - +ve TCK/SK on read
Bit 3 LSB first
Bit 4 Write TDI/DO
Bit 5 Read TDO/DI
Bit 6 Write TMS/CS
Bit 7 Used to check for error.
*/


//==============================================
//	FTDI Subroutine
//==============================================
BOOL	FTDI_OpenDevice(void);
BOOL	FTDI_CloseDevice(void);
BOOL	FTDI_Initialize(void);
BOOL	FTDI_PurgeBuffer(void);
BOOL	FTDI_TransferBuffer(BYTE* pbyTxBuffer, DWORD dwTxSize);
BOOL	FTDI_WaitQueue(DWORD dwRxSize, DWORD dwTimeOutMs);
BOOL	FTDI_ReceiveBuffer(BYTE* pbyRxBuffer, DWORD dwRxSize);
BOOL	FTDI_WaitReceiveBuffer(BYTE* pbyRxBuffer, DWORD dwRxSize, DWORD dwTimeOutMs);
BOOL	FTDI_SetClkDivisor(WORD wDivisor);
BOOL	FTDI_SetLatencyTimer(UCHAR ucTimer);
BOOL	FTDI_SetTimeouts(ULONG ulReadTimeout, ULONG ulWriteTimeout);
BOOL	FTDI_SetUSBParameters(ULONG ulInTransferSize, ULONG ulOutTransferSize);
BOOL	FTDI_SetPortEx(BYTE byPortType, BYTE byPortData, BYTE byPortDir);
BOOL	FTDI_SetPort(BYTE byPortType, BYTE byPortData, BYTE byPortDir);
BOOL	FTDI_GetPort(BYTE byPortType, BYTE* pbyPortData);


